#ifndef CMDS_C
#define CMDS_C

#include "cmds.h"

//save/load config//////////////////////////////////////////////////////////////
void config_cmd(unsigned char* data)
{
  if(strcmpbeg(data,"config save")==1)
  {
    save_config();
    return;
  }
  if(strcmpbeg(data,"config load")==1)
  {
    load_config();
    return;
  }
  if(strcmpbeg(data,"config help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<35;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Config");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("config save           Save the current configuration to flash.\n");
    vga_write_output(CHECKMARK);
    vga_output("config load           Load a configuration from flash memory.\n\n");
    vga_output("This saves logging, filter and verbosity settings to flash\nso you can reload them later. \n\n");
    return;
  }
  cmdErrMsg("");
}

//display system splash screen//////////////////////////////////////////////////
void splash(unsigned char* data)
{
  if(strcmpbeg(data,"splash help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<35;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Splash");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("splash            Display system splash screen and credits.\n\n");
    vga_output("This shows the splash screen you see when the system starts up.\n\n");
    return;
  }
  lcd_string("e-Sniff (c)2006\nBy Alex Hoyland",31);
  vga_status("\nInitializing system...");
  char splashL1[22] = {ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,ARROWRT,SPACE,'\n'};
  char splashL2[2] = {'\n','\0'};
  char splashL3[21] = {REDSQ,REDSQ,REDSQ,SPACE,BLUSQ,BLUSQ,BLUSQ,SPACE,SPACE,SPACE,SPACE,SPACE,BLUSQ,SPACE,BLUSQ,BLUSQ,SPACE,BLUSQ,BLUSQ,'\n','\0'};
  char splashL4[20] = {REDSQ,SPACE,SPACE,SPACE,BLUSQ,SPACE,SPACE,SPACE,SPACE,SPACE,SPACE,SPACE,SPACE,SPACE,BLUSQ,SPACE,SPACE,BLUSQ,'\n','\0'};
  char splashL5[21] = {REDSQ,REDSQ,REDSQ,SPACE,BLUSQ,BLUSQ,BLUSQ,SPACE,BLUSQ,BLUSQ,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,BLUSQ,SPACE,BLUSQ,BLUSQ,'\n','\0'};
  char splashL6[21] = {REDSQ,SPACE,SPACE,SPACE,SPACE,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,SPACE,BLUSQ,SPACE,'\n','\0'};
  char splashL7[21] = {REDSQ,REDSQ,REDSQ,SPACE,BLUSQ,BLUSQ,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,BLUSQ,SPACE,SPACE,BLUSQ,SPACE,'\n','\0'};
  char splashL8[22] = {ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,ARROWLFT,SPACE,'\n','\0'};
  vga_output("\n                              ");
  vga_output(splashL1);
  vga_output("                              ");
  vga_output(splashL2);
  vga_output("                              ");
  vga_output(splashL3);
  vga_output("                              ");
  vga_output(splashL4);
  vga_output("                              ");
  vga_output(splashL5);
  vga_output("                              ");
  vga_output(splashL6);
  vga_output("                              ");
  vga_output(splashL7);
  vga_output("\n                              ");
  vga_output("  By Alex Hoyland\n\n");
  vga_output("                              ");
  vga_output(splashL8);
  vga_output("\n\ne-sniff System Software v1.0 Copyright 2006 by Alexander Hoyland and Bradley\nUniversity.  ");
  vga_output("Special thanks to Dr. Aleksander Malinowski, Steven Gutschlag,\nMary Lou Kesse and ");
  vga_output("Dr. Eric Crabill.  DM9000A interface (c)2006 Terasic Inc.\nAll other rights");
  vga_output(" reserved.  For questions or comments call (217) 891-1970.\n\n");
}

//display system info///////////////////////////////////////////////////////////
void sysinfo(unsigned char* data)
{
  //implement help
  if(strcmpbeg(data,"sysinfo help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<34;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Sysinfo");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("sysinfo           Display system ID, speed and MAC address.\n\n");
    vga_output("Show some basic information about the E-Sniff system.\n\n");
    return;
  }
  unsigned short int i;
  vga_output("System Info:\n");
  vga_write_output(ARROWRT);
  vga_output("System clock speed is "); 
  vga_dec_output(ALT_CPU_FREQ/1000000);
  vga_output(" MHz.\n");
  vga_write_output(ARROWRT);
  vga_output("Nios II system ID is ");
  vga_hex_output((SYSID_ID&0xFF000000)>>24,1);
  vga_hex_output((SYSID_ID&0x00FF0000)>>16,0);
  vga_hex_output((SYSID_ID&0x0000FF00)>>8,0);
  vga_hex_output((SYSID_ID&0x000000FF),0);
  vga_return_output();
  vga_write_output(ARROWRT);
  vga_output("MAC address is ");
  vga_hex_output(ether_addr[0],1);
  for(i=1;i<6;i++)
  {
    vga_hex_output(ether_addr[i],0); 
  }
  vga_output("\n\n");
}

//start/stop capture////////////////////////////////////////////////////////////
void setCapture(unsigned char* data)
{
  //implement help
  if(strcmpbeg(data,"capture help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<34;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Capture");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("capture start     Start packet capture\n");
    vga_write_output(CHECKMARK);
    vga_output("capture stop      Stop packet capture\n\n");
    vga_output("This allows you to enable or disable the ethernet interrupt ");
    vga_output("that handles\npacket processing.  When the interrupt is restarted, the ethernet controller\nis reinitialized.\n\n");
    return;  
  }
  //stop capture
  if (strcmpbeg(data, "capture stop")==1)
  {
    if(capturing==1)
    {
      vga_write_output(CHECKMARK);
      vga_output("Stopping capture...\n\n");
      alt_irq_disable(DM9000A_IRQ);
      capturing = 0;
    }
    else
    {
      vga_write_output(REDX);
      vga_output("Capture is already stopped.\n\n");
    }
    return;
  }
  //start capture
  if (strcmpbeg(data, "capture start")==1)
  {
    if(capturing==0)  
    {
      vga_write_output(CHECKMARK);
      vga_output("Starting capture...\n\n");
      DM9000_init();
      alt_irq_enable(DM9000A_IRQ);
      capturing = 1;
    }
    else
    {
      vga_write_output(REDX);
      vga_output("Already capturing.\n\n");
    }
      
    return;
  }
  cmdErrMsg("");
}

//show praise and reviews///////////////////////////////////////////////////////
void praise(unsigned char* data)
{ 
  //implement help
  if(strcmpbeg(data,"praise help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<35;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Praise");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("praise            Consumer reviews of the E-sniff project.\n\n");
    vga_output("These rave reviews were given by some of E-Sniff's biggest fans.\n\n");
    return;
  }
  //show praise
  vga_output("Praise for the E-sniff project:\n\n");
  vga_write_output(ARROWRT);
  vga_output("E-sniff sniffs better than other leading sniffers sniff - Derek Carlson\n");
  vga_write_output(ARROWRT);
  vga_output("E-sniff is tha most ballinest sniffa evah - don't hate tha sniffah,\n hate tha game - Caleb \"C-Money\" Anderson\n");
  vga_write_output(ARROWRT);
  vga_output("E-sniff is teh pwnzor it will h4x0r all teh in73rn375 and pwn teh n00B5 lolz\n will h4xor teh hidden pr0n h311z y34h - elven_lord_1337\n");
  vga_write_output(ARROWRT);
  vga_output("E-sniff is the holiest, most sainted sniffer ever.  If you use it you will \n attain life everlasting- Mohammed, Buddha, Jesus, all 12 apostles & Santa\n");
  vga_write_output(ARROWRT);
  vga_output("E-sniff? What the hell is E-sniff? Go away. - Random Street Person\n\n");
};

//show homer////////////////////////////////////////////////////////////////////
void homer(unsigned char* data)
{
  //implement help
  if(strcmpbeg(data,"homer help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Homer");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("homer             Learn to appreciate classy artwork.\n\n");
    vga_output("This shows an ASCII picture of an axe-wielding Homer Simpson from chris.com\n\n");
    return;
  }
  //show homer
  unsigned short int i=0;
  for(i=0;i<35;i++)
  {
    vga_write_output(ARROWRT);
  }
  
  vga_output("Homer");
  for(i=0;i<35;i++)
  {
    vga_write_output(ARROWLFT);
  } 
  vga_output("\n                                                     ___,------, \n");
  vga_output("             _,--.---.                         __,--'         / \n");
  vga_output("           ,' _,'_`._ \\                    _,-'           ___,| \n");
  vga_output("          ;--'       `^-.                ,'        __,---'   || \n");
  vga_output("        ,'               \\             ,'      _,-'          || \n");
  vga_output("       /                  \\         _,'     ,-'              || \n");
  vga_output("      :                    .      ,'     _,'                 |: \n");
  vga_output("      |                    :     `.    ,'                    |: \n");
  vga_output("      |           _,-      |       `-,'                      :: \n");
  vga_output("     ,'____ ,  ,-'  `.   , |,         `.                     : \\ \n");
  vga_output("     ,'    `-,'       ) / \\/ \\          \\                     : : \n");
  vga_output("     |      _\\   o _,-'    '-.           `.                    \\ \\ \n");
  vga_output("      `o_,-'  `-,-' ____   ,` )-.______,'  `.                   : : \n");
  vga_output("       \\-\\    _,---'    `-. -'.\\  `.  /     `.                  \\  \\ \n");
  vga_output("        / `--'             `.   \\   \\:        \\                  \\,.\\ \n");
  vga_output("       (              ____,  \\  |    \\        \\                 :\\ \\ \n");
  vga_output("        )         _,-'    `   | |    | \\        \\                 \\_\\ \n");
  vga_output("       /      _,-'            | |   ,'-`._      _\\                 \\,' \n");
  vga_output("       `-----' |`-.           ;/   (__ ,' `-. _;-'`\\           _,--' \n");
  vga_output("     ,'        |   `._     _,' \\-._/  Y    ,-'      \\      _,-' \n");
  vga_output("    /        _ |      `---'    :,-|   |    `     _,-'\\_,--'   \\ \n");
  vga_output("   :          `|       \\`-._   /  |   '     `.,-' `._`         \\ \n");
  vga_output("   |           _\\_    _,\\/ _,-'|                     `-._       \\ \n");
  vga_output("   :   ,-         `.-'_,--'    \\                         `       \\ \n");
  vga_output("   | ,'           ,--'      _,--\\           _,                    : \n");
  vga_output("    )         .    \\___,---'   ) `-.____,--'                      | \n");
  vga_output("   _\\    .     `    ||        :            \\                      ; \n");
  vga_output(" ,'  \\    `.    )--' ;        |             `-.                  / \n");
  vga_output("|     \\     ;--^._,-'         |                `-._            _/_\\ \n");
  vga_output("\\    ,'`---'                  |                    `--._____,-'_'  \\ \n");
  vga_output(" \\_,'                         `._                          _,-'     ` \n");
  vga_output("                            ,-'  `---.___           __,---' \n");
  vga_output("                          ,'             `---------' \n");
  vga_output("                        ,' \n");
  vga_output("NO TV AND NO BEER MAKE HOMER GO CRAZY\n");
  vga_output("image courtesy of chris.com - http://chris.com/ascii\n\n");
  for(i=0;i<39;i++)
  {
    vga_write_output(ARROWRT);
  }
  for(i=0;i<39;i++)
  {
    vga_write_output(ARROWLFT);
  }
  vga_return_output();
  vga_return_output();
}

//show help/////////////////////////////////////////////////////////////////////
void help(unsigned char* data)
{
  //print a nice border
  unsigned short int i=0;
  for(i=0;i<32;i++)
  {
    vga_write_output(ARROWRT);
  }
  
  vga_output("E-Sniff Help");
  for(i=0;i<32;i++)
  {
    vga_write_output(ARROWLFT);
  }
  vga_output("\n\nBelow is a list of supported commands.  Type <command> help for \n");
  vga_output("more information on any command.\n\n");
  vga_write_output(CHECKMARK);
  vga_output("capture           Start or stop packet capture.\n");
  vga_write_output(CHECKMARK);
  vga_output("filter            Adjust the packet filter.\n");
  vga_write_output(CHECKMARK);
  vga_output("verbosity         Control the detail displayed about each packet.\n");
  vga_write_output(CHECKMARK);
  vga_output("log               Control the logging of packets to flash memory.\n");
  vga_write_output(CHECKMARK);
  vga_output("config            Save/load the current system configuration.\n");
  vga_write_output(CHECKMARK);
  vga_output("status            Change what is displayed in the status bar.\n");
  vga_write_output(CHECKMARK);
  vga_output("sysinfo           Display basic information about the system.\n");
  vga_write_output(CHECKMARK);
  vga_output("splash            Display the system splash screen and credits.\n");
  vga_write_output(CHECKMARK);
  vga_output("praise            Display consumer reviews of the E-Sniff system.\n");
  vga_write_output(CHECKMARK);
  vga_output("homer             Learn to appreciate classy artwork.\n\n");
};

//show a filter rule////////////////////////////////////////////////////////////
void filterRuleShow(int i)
{
  unsigned int j;
  if((filter_Rules[i].active & FILTER_RULE_ACTIVE)==FILTER_RULE_ACTIVE)
  {
 
    vga_output("  ");
    vga_write_output(CHECKMARK);
    vga_output("Filter rule ");
    vga_hex_output(i+1,0);
    vga_output(" is enabled.\n");
    if((filter_Rules[i].active & FILTER_SRCMAC_ACTIVE)==FILTER_SRCMAC_ACTIVE)
    {
      vga_output("    Source MAC address: ");
      vga_hex_output(filter_Rules[i].src_mac[0],1);
      for(j=1;j<6;j++)
        vga_hex_output(filter_Rules[i].src_mac[j],0);
      vga_return_output();
    }
    if((filter_Rules[i].active & FILTER_DESTMAC_ACTIVE)==FILTER_DESTMAC_ACTIVE)
    {
      vga_output("    Destination MAC address: ");
      vga_hex_output(filter_Rules[i].dest_mac[0],1);
      for(j=1;j<6;j++)
        vga_hex_output(filter_Rules[i].dest_mac[j],0);
      vga_return_output();
    }
    if((filter_Rules[i].active & FILTER_SRCIP_ACTIVE)==FILTER_SRCIP_ACTIVE)
    {
      vga_output("     Source IP address: ");
      vga_dec_output(filter_Rules[i].src_ip[0]);
      vga_write_output('.');
      for(j=1;j<3;j++)
      {
        vga_dec_output(filter_Rules[i].src_ip[j]);
        vga_write_output('.');
      }
      vga_dec_output(filter_Rules[i].src_ip[3]);
      vga_return_output();
      vga_output("     Source IP netmask: ");
      vga_dec_output(filter_Rules[i].src_netmask[0]);
      vga_write_output('.');
      for(j=1;j<3;j++)
      {
        vga_dec_output(filter_Rules[i].src_netmask[j]);
        vga_write_output('.');
      }
      vga_dec_output(filter_Rules[i].src_netmask[3]);
      vga_return_output();
    }
    if((filter_Rules[i].active & FILTER_DESTIP_ACTIVE)==FILTER_DESTIP_ACTIVE)
    {
      vga_output("     Destination IP address: ");
      vga_dec_output(filter_Rules[i].dest_ip[0]);
      vga_write_output('.');
      for(j=1;j<3;j++)
      {
        vga_dec_output(filter_Rules[i].dest_ip[j]);
        vga_write_output('.');
      }
      vga_dec_output(filter_Rules[i].dest_ip[3]);
      vga_return_output();
      vga_output("     Destination IP netmask: ");
      vga_dec_output(filter_Rules[i].dest_netmask[0]);
      vga_write_output('.');
      for(j=1;j<3;j++)
      {
        vga_dec_output(filter_Rules[i].dest_netmask[j]);
        vga_write_output('.');
      }
      vga_dec_output(filter_Rules[i].dest_netmask[3]);
      vga_return_output();
    }
    if((filter_Rules[i].active & FILTER_PROTO_ACTIVE)==FILTER_PROTO_ACTIVE)
    {
       vga_output("    Protocol: ");
       switch(filter_Rules[i].protocol)
       {
          case FILTER_PROTO_ARP:
            vga_output("ARP\n");
            break;
          case FILTER_PROTO_IP:
            vga_output("IP\n");
            break;
          case FILTER_PROTO_TCP:
            vga_output("TCP\n");
            break;
          case FILTER_PROTO_UDP:
            vga_output("UDP\n");
            break;
       }
    }
    if((filter_Rules[i].active & FILTER_SPORT_ACTIVE)==FILTER_SPORT_ACTIVE)
    {
      vga_output("     Source port: ");
      vga_dec_output((filter_Rules[i].src_port[0]<<8)|(filter_Rules[i].src_port[1]));
      vga_return_output();
    }
    if((filter_Rules[i].active & FILTER_DPORT_ACTIVE)==FILTER_DPORT_ACTIVE)
    {
      vga_output("     Destination port: ");
      vga_dec_output((filter_Rules[i].dest_port[0]<<8)|(filter_Rules[i].dest_port[1]));
      vga_return_output();
    }
  }
  else
  {
    vga_output("  ");
    vga_write_output(REDX);
    vga_output("Filter rule ");
    vga_hex_output(i+1,0);
    vga_output(" is disabled.\n");
  } 
}

//commands that affect the filter///////////////////////////////////////////////
void setFilter(unsigned char* data)
{
  unsigned int i;
  //turn on the filter//////////////////////////////////////////////////////////
  if(strcmpbeg(data,"filter on")==1)
  {
    filter_On = FILTER_ACTIVE;
    vga_write_output(CHECKMARK);
    vga_output("Filter activated.\n\n");
    return; 
  }
  //turn off the filter//////////////////////////////////////////////////////////
  if(strcmpbeg(data,"filter off")==1)
  {
    filter_On = FILTER_INACTIVE;
    vga_write_output(CHECKMARK);
    vga_output("Filter deactivated.\n\n");
    return; 
  }
  //show the filter/////////////////////////////////////////////////////////////
  if (strcmpbeg(data,"filter show")==1)
  {
    //show filter status
    if(filter_On == FILTER_ACTIVE)
    {
      vga_write_output(CHECKMARK);
      vga_output("The filter is enabled.\n"); 
    }
    else
    {
      vga_write_output(REDX);
      vga_output("The filter is disabled.\n"); 
    }
    //show filter rule status
    for(i=0;i<5;i++)
    {
      filterRuleShow(i);
    }
    vga_return_output();
    return;
  }
  //activate a filter rule//////////////////////////////////////////////////////////
  if((strcmpbeg(data,"filter ")==1)&&(strcmpbeg(data+8," on")))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Filter rule ");
      vga_hex_output(rulenum,0);
      vga_output(" activated.\n\n");
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active | FILTER_RULE_ACTIVE;
      return;
    }
  }
  //deactivate a filter rule//////////////////////////////////////////////////////////
  if((strcmpbeg(data,"filter ")==1)&&(strcmpbeg(data+8," off")))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Filter rule ");
      vga_hex_output(rulenum,0);
      vga_output(" deactivated.\n\n");
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & (FILTER_RULE_INACTIVE);
      return;
    }
  }
  //show a filter rule//////////////////////////////////////////////////////////
  if((strcmpbeg(data,"filter ")==1)&&(strcmpbeg(data+8," show")))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      filterRuleShow(rulenum-1);
      vga_return_output();
      return;
    }
  }
  //set a rule's source mac address/////////////////////////////////////////////
  if((strcmpbeg(data,"filter ")==1)&&(strcmpbeg(data+8," src-mac 0x")))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      rulenum--;
      unsigned char mac_addy[6];
      unsigned short int i;
      //convert MAC from 12 ASCII chars to 6 hex chars
      for(i=0;i<6;i++)
      {
        //stop if there's not enough characters
        if(data[19+2*i]=='\0' || data[20+2*i]=='\0')
          break;
        //stop if the character is not 1234567890ABCDE or F
        if(data[19+2*i]<0x30 || (data[19+2*i]>0x39 && data[19+2*i]<41) || data[19+2*i]>0x46)
          break;
        if(data[20+2*i]<0x30 || (data[20+2*i]>0x39 && data[20+2*i]<41) || data[20+2*i]>0x46)
          break;
        //the actual conversion - bit packing is gay...
        unsigned short int nibble1 = (data[19+2*i]<0x3A) ? (data[19+2*i]-0x30) : (data[19+2*i]-0x37);
        unsigned short int nibble2 = (data[20+2*i]<0x3A) ? (data[20+2*i]-0x30) : (data[20+2*i]-0x37);
        mac_addy[i]=(nibble1<<4)|nibble2;
        //set filter rule value and return
        if(i==5)
        {
          filter_Rules[rulenum].src_mac[0] = mac_addy[0];
          filter_Rules[rulenum].src_mac[1] = mac_addy[1];
          filter_Rules[rulenum].src_mac[2] = mac_addy[2];
          filter_Rules[rulenum].src_mac[3] = mac_addy[3];
          filter_Rules[rulenum].src_mac[4] = mac_addy[4];
          filter_Rules[rulenum].src_mac[5] = mac_addy[5];
          filter_Rules[rulenum].active = filter_Rules[rulenum].active | FILTER_SRCMAC_ACTIVE | FILTER_RULE_ACTIVE;
      vga_write_output(CHECKMARK);
          vga_output("Set source MAC address for filter rule ");
          vga_hex_output(rulenum+1,0);
          vga_return_output();
          vga_return_output();
          return; 
        }
      }
    }
  }
  //remove a source mac address from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," src-mac none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed source mac address from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_SRCMAC_ACTIVE;
      return;
    }
  }
    //set a rule's destination mac address/////////////////////////////////////////////
  if((strcmpbeg(data,"filter ")==1)&&(strcmpbeg(data+8," dst-mac 0x")))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      rulenum--;
      unsigned char mac_addy[6];
      unsigned short int i;
      //convert MAC from 12 ASCII chars to 6 hex chars
      for(i=0;i<6;i++)
      {
        //stop if there's not enough characters
        if(data[19+2*i]=='\0' || data[20+2*i]=='\0')
          break;
        //stop if the character is not 1234567890ABCDE or F
        if(data[19+2*i]<0x30 || (data[19+2*i]>0x39 && data[19+2*i]<41) || data[19+2*i]>0x46)
          break;
        if(data[20+2*i]<0x30 || (data[20+2*i]>0x39 && data[20+2*i]<41) || data[20+2*i]>0x46)
          break;
        //the actual conversion - bit packing is gay...
        unsigned short int nibble1 = (data[19+2*i]<0x3A) ? (data[19+2*i]-0x30) : (data[19+2*i]-0x37);
        unsigned short int nibble2 = (data[20+2*i]<0x3A) ? (data[20+2*i]-0x30) : (data[20+2*i]-0x37);
        mac_addy[i]=(nibble1<<4)|nibble2;
        //set filter rule value and return
        if(i==5)
        {
          filter_Rules[rulenum].dest_mac[0] = mac_addy[0];
          filter_Rules[rulenum].dest_mac[1] = mac_addy[1];
          filter_Rules[rulenum].dest_mac[2] = mac_addy[2];
          filter_Rules[rulenum].dest_mac[3] = mac_addy[3];
          filter_Rules[rulenum].dest_mac[4] = mac_addy[4];
          filter_Rules[rulenum].dest_mac[5] = mac_addy[5];
          filter_Rules[rulenum].active = filter_Rules[rulenum].active | FILTER_DESTMAC_ACTIVE | FILTER_RULE_ACTIVE;
      vga_write_output(CHECKMARK);
          vga_output("Set destination MAC address for filter rule ");
          vga_hex_output(rulenum+1,0);
          vga_return_output();
          vga_return_output();
          return; 
        }
      }
    }
  }
  //remove a destination mac address from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," dst-mac none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed destination mac address from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_DESTMAC_ACTIVE;
      return;
    }
  }
  //remove a source ip address from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," src-ip none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed source ip address from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_SRCIP_ACTIVE;
      return;
    }
  }
  //set a rule's source ip and netmask//////////////////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," src-ip "))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      //this points to where the ip address should begin
      unsigned char * TxtPtr = data+16;
      
      //this holds the ip address until everything is validated
      //use longs so we can see if any octet is over 255
      unsigned long int ip_addr[4];
      
      //this is the octet index
      int octet=0;

      /*Parse out the IP address*/
      
      //for each of 4 octets, validate and translate the ip
      for(octet=0;octet<4;octet++)
      {
      
        //this holds the number of digits in the each octet
        unsigned short int digitsInOctet = 0;
        
        //a period terminates an octet, and a \ precedes the netmask
        while((*TxtPtr!='.'))
        {
          //if the octet is 3 and the next char is '\', start netmask
          if(octet==3 && *TxtPtr=='\\')
            break;
          
          //this ip address contains invalid characters, quit
          if(*TxtPtr>0x39 || *TxtPtr<0x30)
          {
            vga_write_output(REDX);
            vga_output("This IP address contains invalid characters.\n");
            cmdErrMsg("");
            return;
          }
          //else, show that there is one more digit in the octet
          digitsInOctet++;
          //if there are more than 3 digits in this octet, quit
          if(digitsInOctet>3)
            break;
          //check the next character
          TxtPtr++; 
        }
        
        //if there is at least one number before there is a period, parse out the octet
        switch(digitsInOctet)
        {
        //there is one digit in the octet
        case 1:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          break;
        
        //there are 2 digits in the octet
        case 2:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          ip_addr[octet] += 10*(0x0F & (*(TxtPtr-2)));
          break;
          
        //there are 3 digits in the octet
        case 3:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          ip_addr[octet] += 10*(0x0F & (*(TxtPtr-2)));
          ip_addr[octet] += 100*(0x0F & (*(TxtPtr-3)));
          //octets cannot be greater than 255 - fix this, range limited
          if(ip_addr[octet] >255)
          {
            vga_write_output(REDX);
            vga_output("No octets > 255, dummy.\n");
            cmdErrMsg("");
            return; 
          }
          break;
        
        //if there are not 1,2, or 3 digits in the octet, quit
        default:
          cmdErrMsg("");
          return;
        }
        
        //indicate start of next octet
        TxtPtr++;
        
        //if octet is 3, we're done, break
        if(octet==3)
          break;
      }
            
      /*Parse out the netmask*/
      
      //if netmask cotains non-numeric characters, error
      if(*TxtPtr>0x39 || *TxtPtr<0x30 || *(TxtPtr+1)<0x30 || *(TxtPtr+1)>0x39)
      {
         vga_write_output(REDX);
         vga_output("Invalid Netmask.\n");
         cmdErrMsg("");
         return;
      }
      //add up the netmask
      int netmask = 10*((*TxtPtr) & 0x0F);
      TxtPtr++;
      netmask += ((*TxtPtr) & 0x0F);
      //if netmask > 32, error
      if(netmask > 32)
      {
         vga_write_output(REDX);
         vga_output("Invalid Netmask.\n");
         cmdErrMsg("");
         return;
      }
      
      /*Save the results to the filter*/
      
      filter_Rules[rulenum-1].src_ip[0] = ip_addr[0];
      filter_Rules[rulenum-1].src_ip[1] = ip_addr[1];
      filter_Rules[rulenum-1].src_ip[2] = ip_addr[2];
      filter_Rules[rulenum-1].src_ip[3] = ip_addr[3];
      
      if(netmask>24)
      {
        filter_Rules[rulenum-1].src_netmask[0]=0xFF;
        filter_Rules[rulenum-1].src_netmask[1]=0xFF;
        filter_Rules[rulenum-1].src_netmask[2]=0xFF;
        filter_Rules[rulenum-1].src_netmask[3]=(0xFF<<(32-netmask));
      }
      if(netmask>16 && netmask<=24)
      {
        filter_Rules[rulenum-1].src_netmask[0]=0xFF;
        filter_Rules[rulenum-1].src_netmask[1]=0xFF;
        filter_Rules[rulenum-1].src_netmask[2]=(0xFF<<(24-netmask));
        filter_Rules[rulenum-1].src_netmask[3]=0x00;
      }
      if(netmask>8 && netmask<=16)
      {
        filter_Rules[rulenum-1].src_netmask[0]=0xFF;
        filter_Rules[rulenum-1].src_netmask[2]=(0xFF<<(16-netmask));        
        filter_Rules[rulenum-1].src_netmask[2]=0x00;
        filter_Rules[rulenum-1].src_netmask[3]=0x00; 
      }
      if(netmask<=8)
      {
        filter_Rules[rulenum-1].src_netmask[0]=(0xFF<<(8-netmask));
        filter_Rules[rulenum-1].src_netmask[1]=0x00;
        filter_Rules[rulenum-1].src_netmask[2]=0x00;
        filter_Rules[rulenum-1].src_netmask[3]=0x00; 
      }
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active | FILTER_SRCIP_ACTIVE | FILTER_RULE_ACTIVE;
      
      /*Show Confirmation*/
      vga_write_output(CHECKMARK);
      vga_output("Set filter rule ");
      vga_dec_output(rulenum);
      vga_output(" source ip to ");
      vga_dec_output(ip_addr[0]);
      vga_write_output('.');
      vga_dec_output(ip_addr[1]);
      vga_write_output('.');
      vga_dec_output(ip_addr[2]);
      vga_write_output('.');
      vga_dec_output(ip_addr[3]);
      vga_output(", mask ");
      vga_dec_output(filter_Rules[rulenum-1].src_netmask[0]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].src_netmask[1]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].src_netmask[2]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].src_netmask[3]);
      vga_return_output();
      vga_return_output();
      return;
    }
  }
  //remove a destination ip address from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," dst-ip none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed destination ip address from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_DESTIP_ACTIVE;
      return;
    }
  }
  //set a rule's destination ip and netmask/////////////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," dst-ip "))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      //this points to where the ip address should begin
      unsigned char * TxtPtr = data+16;
      
      //this holds the ip address until everything is validated
      //use longs so we can see if any octet is over 255
      unsigned long int ip_addr[4];
      
      //this is the octet index
      int octet=0;

      /*Parse out the IP address*/
      
      //for each of 4 octets, validate and translate the ip
      for(octet=0;octet<4;octet++)
      {
      
        //this holds the number of digits in the each octet
        unsigned short int digitsInOctet = 0;
        
        //a period terminates an octet, and a \ precedes the netmask
        while((*TxtPtr!='.'))
        {
          //if the octet is 3 and the next char is '\', start netmask
          if(octet==3 && *TxtPtr=='\\')
            break;
          
          //this ip address contains invalid characters, quit
          if(*TxtPtr>0x39 || *TxtPtr<0x30)
          {
            vga_write_output(REDX);
            vga_output("This IP address contains invalid characters.\n");
            cmdErrMsg("");
            return;
          }
          //else, show that there is one more digit in the octet
          digitsInOctet++;
          //if there are more than 3 digits in this octet, quit
          if(digitsInOctet>3)
            break;
          //check the next character
          TxtPtr++; 
        }
        
        //if there is at least one number before there is a period, parse out the octet
        switch(digitsInOctet)
        {
        //there is one digit in the octet
        case 1:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          break;
        
        //there are 2 digits in the octet
        case 2:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          ip_addr[octet] += 10*(0x0F & (*(TxtPtr-2)));
          break;
          
        //there are 3 digits in the octet
        case 3:
          ip_addr[octet] = 0x0F & (*(TxtPtr-1));
          ip_addr[octet] += 10*(0x0F & (*(TxtPtr-2)));
          ip_addr[octet] += 100*(0x0F & (*(TxtPtr-3)));
          //octets cannot be greater than 255 - fix this, range limited
          if(ip_addr[octet] >255)
          {
            vga_write_output(REDX);
            vga_output("No octets > 255, dummy.\n");
            cmdErrMsg("");
            return; 
          }
          break;
        
        //if there are not 1,2, or 3 digits in the octet, quit
        default:
          cmdErrMsg("");
          return;
        }
        
        //indicate start of next octet
        TxtPtr++;
        
        //if octet is 3, we're done, break
        if(octet==3)
          break;
      }
            
      /*Parse out the netmask*/
      
      //if netmask cotains non-numeric characters, error
      if(*TxtPtr>0x39 || *TxtPtr<0x30 || *(TxtPtr+1)<0x30 || *(TxtPtr+1)>0x39)
      {
         vga_write_output(REDX);
         vga_output("Invalid Netmask.\n");
         cmdErrMsg("");
         return;
      }
      //add up the netmask
      int netmask = 10*((*TxtPtr) & 0x0F);
      TxtPtr++;
      netmask += ((*TxtPtr) & 0x0F);
      //if netmask > 32, error
      if(netmask > 32)
      {
         vga_write_output(REDX);
         vga_output("Invalid Netmask.\n");
         cmdErrMsg("");
         return;
      }
      
      /*Save the results to the filter*/
      
      filter_Rules[rulenum-1].dest_ip[0] = ip_addr[0];
      filter_Rules[rulenum-1].dest_ip[1] = ip_addr[1];
      filter_Rules[rulenum-1].dest_ip[2] = ip_addr[2];
      filter_Rules[rulenum-1].dest_ip[3] = ip_addr[3];
      
      if(netmask>24)
      {
        filter_Rules[rulenum-1].dest_netmask[0]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[1]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[2]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[3]=(0xFF<<(32-netmask));
      }
      if(netmask>16 && netmask<=24)
      {
        filter_Rules[rulenum-1].dest_netmask[0]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[1]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[2]=(0xFF<<(24-netmask));
        filter_Rules[rulenum-1].dest_netmask[3]=0x00;
      }
      if(netmask>8 && netmask<=16)
      {
        filter_Rules[rulenum-1].dest_netmask[0]=0xFF;
        filter_Rules[rulenum-1].dest_netmask[2]=(0xFF<<(16-netmask));        
        filter_Rules[rulenum-1].dest_netmask[2]=0x00;
        filter_Rules[rulenum-1].dest_netmask[3]=0x00; 
      }
      if(netmask<=8)
      {
        filter_Rules[rulenum-1].dest_netmask[0]=(0xFF<<(8-netmask));
        filter_Rules[rulenum-1].dest_netmask[1]=0x00;
        filter_Rules[rulenum-1].dest_netmask[2]=0x00;
        filter_Rules[rulenum-1].dest_netmask[3]=0x00; 
      }
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active | FILTER_DESTIP_ACTIVE | FILTER_RULE_ACTIVE;
      
      /*Show Confirmation*/
      vga_write_output(CHECKMARK);
      vga_output("Set filter rule ");
      vga_dec_output(rulenum);
      vga_output(" destination ip to ");
      vga_dec_output(ip_addr[0]);
      vga_write_output('.');
      vga_dec_output(ip_addr[1]);
      vga_write_output('.');
      vga_dec_output(ip_addr[2]);
      vga_write_output('.');
      vga_dec_output(ip_addr[3]);
      vga_output(", mask ");
      vga_dec_output(filter_Rules[rulenum-1].dest_netmask[0]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].dest_netmask[1]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].dest_netmask[2]);
      vga_write_output('.');
      vga_dec_output(filter_Rules[rulenum-1].dest_netmask[3]);
      vga_return_output();
      vga_return_output();
      return;
    }
  }
  //remove a source port from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," src-port none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed source port from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_SPORT_ACTIVE;
      return;
    }
  }
  //remove a destination port from a filter rule//////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," dst-port none"))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      vga_write_output(CHECKMARK);
      vga_output("Removed destination port from filter rule ");
      vga_hex_output(rulenum,0);
      vga_return_output();
      vga_return_output();
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active & ~FILTER_DPORT_ACTIVE;
      return;
    }
  }
  //set a filter rule's source port/////////////////////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," src-port "))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      //points to start of port number
      unsigned char *TxtPtr = data+18;
      
      //how many chars in port number?
      unsigned short int digitsInPortNum=0;
      
      //port number
      unsigned long int srcPortNum=0;
      
      //add up port number
      while(*TxtPtr != ' ')
      {
        //make sure it's a number
        if(*TxtPtr<0x30 || *TxtPtr>0x39)
        {
          vga_write_output(REDX);
          vga_output("Invalid Port Number.\n");
          cmdErrMsg("");
          return;
        }
        digitsInPortNum++;
       
        //if there's more than 5 digits, quit
        if(digitsInPortNum>5)
        {
          vga_write_output(REDX);
          vga_output("Invalid Port Number.\n");
          cmdErrMsg("");
          return;
        }
       
        //multiply what's in there by ten since there's another digit, then add
        srcPortNum=srcPortNum*10;
        srcPortNum+=(*TxtPtr & 0x0F);
        *TxtPtr++;
      }     
  
      //make sure smaller than 65535
      if(srcPortNum>65535)
      {
        vga_write_output(REDX);
        vga_output("Invalid Port Number.\n");
        cmdErrMsg("");
        return;
      }
    
      //save to filter
      filter_Rules[rulenum-1].src_port[0] = ((srcPortNum & 0xFF00)>>8);
      filter_Rules[rulenum-1].src_port[1] = (srcPortNum & 0x00FF);
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active | FILTER_SPORT_ACTIVE | FILTER_RULE_ACTIVE;
      
      //report success
      vga_write_output(CHECKMARK);
      vga_output("Set source port for filter rule ");
      vga_dec_output(rulenum);
      vga_output(" to ");
      vga_dec_output(srcPortNum);
      vga_output(".\n\n");
      return;      
    }
  }
  //set a filter rule's dest port/////////////////////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," dst-port "))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      //points to start of port number
      unsigned char *TxtPtr = data+18;
      
      //how many chars in port number?
      unsigned short int digitsInPortNum=0;
      
      //port number
      unsigned long int dstPortNum=0;
      
      //add up port number
      while(*TxtPtr != ' ')
      {
        //make sure it's a number
        if(*TxtPtr<0x30 || *TxtPtr>0x39)
        {
          vga_write_output(REDX);
          vga_output("Invalid Port Number.\n");
          cmdErrMsg("");
          return;
        }
        digitsInPortNum++;
       
        //if there's more than 5 digits, quit
        if(digitsInPortNum>5)
        {
          vga_write_output(REDX);
          vga_output("Invalid Port Number.\n");
          cmdErrMsg("");
          return;
        }
       
        //multiply what's in there by ten since there's another digit, then add
        dstPortNum=dstPortNum*10;
        dstPortNum+=(*TxtPtr & 0x0F);
        *TxtPtr++;
      }     
  
      //make sure smaller than 65535
      if(dstPortNum>65535)
      {
        vga_write_output(REDX);
        vga_output("Invalid Port Number.\n");
        cmdErrMsg("");
        return;
      }
    
      //save to filter
      filter_Rules[rulenum-1].dest_port[0] = ((dstPortNum & 0xFF00)>>8);
      filter_Rules[rulenum-1].dest_port[1] = (dstPortNum & 0x00FF);
      filter_Rules[rulenum-1].active = filter_Rules[rulenum-1].active | FILTER_DPORT_ACTIVE | FILTER_RULE_ACTIVE;
      
      //report success
      vga_write_output(CHECKMARK);
      vga_output("Set destination port for filter rule ");
      vga_dec_output(rulenum);
      vga_output(" to ");
      vga_dec_output(dstPortNum);
      vga_output(".\n\n");
      return;      
    }
  }
  //set filter protocol/////////////////////////////////////////////////////////
  if(strcmpbeg(data,"filter ") && strcmpbeg(data+8," proto "))
  {
    int rulenum = data[7] & 0x0F;
    if(rulenum<6 && rulenum>0)
    {
      if(strcmpbeg(data+15,"arp"))
      {
        filter_Rules[rulenum-1].protocol = FILTER_PROTO_ARP;
        filter_Rules[rulenum-1].active = filter_Rules[rulenum].active | FILTER_RULE_ACTIVE | FILTER_PROTO_ACTIVE;
        vga_write_output(CHECKMARK);
        vga_output("Set protocol to arp for filter rule ");
        vga_dec_output(rulenum);
        vga_output(".\n\n"); 
        return;
      }
      if(strcmpbeg(data+15,"ip"))
      {
        filter_Rules[rulenum-1].protocol = FILTER_PROTO_IP;
        filter_Rules[rulenum-1].active = filter_Rules[rulenum].active | FILTER_RULE_ACTIVE | FILTER_PROTO_ACTIVE;
        vga_write_output(CHECKMARK);
        vga_output("Set protocol to ip for filter rule ");
        vga_dec_output(rulenum);
        vga_output(".\n\n"); 
        return;
      }
      if(strcmpbeg(data+15,"tcp"))
      {
        filter_Rules[rulenum-1].protocol = FILTER_PROTO_TCP;
        filter_Rules[rulenum-1].active = filter_Rules[rulenum].active | FILTER_RULE_ACTIVE | FILTER_PROTO_ACTIVE;
        vga_write_output(CHECKMARK);
        vga_output("Set protocol to tcp for filter rule ");
        vga_dec_output(rulenum);
        vga_output(".\n\n"); 
        return;
      }
      if(strcmpbeg(data+15,"udp"))
      {
        filter_Rules[rulenum-1].protocol = FILTER_PROTO_UDP;
        filter_Rules[rulenum-1].active = filter_Rules[rulenum].active | FILTER_RULE_ACTIVE | FILTER_PROTO_ACTIVE;
        vga_write_output(CHECKMARK);
        vga_output("Set protocol to udp for filter rule ");
        vga_dec_output(rulenum);
        vga_output(".\n\n"); 
        return;
      }
      if(strcmpbeg(data+15,"none"))
      {
        filter_Rules[rulenum-1].protocol = FILTER_PROTO_ANY;
        filter_Rules[rulenum-1].active = filter_Rules[rulenum].active & (~FILTER_PROTO_ACTIVE);
        vga_write_output(CHECKMARK);
        vga_output("Removed protocol from filter rule ");
        vga_dec_output(rulenum);
        vga_output(".\n\n"); 
        return;
      }
    }
  }
  //show filter help////////////////////////////////////////////////////////////
  if (strcmpbeg(data,"filter help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Filter");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("filter on                       Turn on the filter.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter off                      Turn off the filter.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter show                     Show all filter rules.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> show           Show filter rule number <rulenum>.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> on             Turn on filter rule number <rulenum>.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> off            Turn off filter rule number <rulenum>.\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> src-mac <mac>  Only allow packets from the physical \n                                 address <mac>\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> src-mac none   Remove the src-mac from a filter rule\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> dst-mac <mac>  Only allow packets going to the \n                                          physical address <mac>\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> dst-mac none   Remove the dst-mac from a filter rule\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> src-ip <addr>\\<netmask>  Only allow packets from the\n                                           specified subnet\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> dst-ip <addr>\\<netmask>  Only allow packets going to\n                                           the specified subnet\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> src-port <port>          Only allow packets from the\n                                           selected port\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> dst-port <port>          Only allow packets going to the\n                                           selected port\n");
    vga_write_output(CHECKMARK);
    vga_output("filter <rulenum> proto <protocol>         Only allow packets using the\n                                           specified protocol.  Options are \n                                           arp ip tcp and udp\n\n");    
    vga_output("The E-Sniff filter supports up to five filtering rules.  If a packet matches\n");
    vga_output("any of the active filter rules, it is passed.  To match a filter rule, a\n");
    vga_output("packet must match all specifications set for that rule.  As an example,\n");
    vga_output("say filter rule 1 says to only match tcp dest-port 60 and src-mac 0x12F69B1234\n");
    vga_output("and rule 2 says to only match tcp dest-port 80.  A packet going from src-mac\n");
    vga_output("0x12F69B1234 on port 80 will match rule 2 and be displayed.  A packet going from\n");
    vga_output("0x3427b9cD78 on port 60 will not match any rule and will not be displayed.\n");
    vga_output("Append 'none' to filter rule adjustment commands to undo them.\n\n");
    return;
  }
  cmdErrMsg("");
};

//commands that affect verbosity////////////////////////////////////////////////
void setVerbosity(unsigned char* data)
{
  if (strcmpbeg(data,"verbosity help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<33;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Verbosity");
    for(i=0;i<34;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("verbosity high    Show all fields of all protocols in all packets.\n");
    vga_write_output(CHECKMARK);
    vga_output("verbosity medium  Show addresses in every layer and application layer data.\n");
    vga_write_output(CHECKMARK);
    vga_output("verbosity low     Show only application-layer data.\n");
    vga_write_output(CHECKMARK);
    vga_output("verbosity none    Packets will be captured with low verbosity to the log.\n                   No packets will be displayed onscreen.\n\n");
    vga_output("The verbosity command allows you to control the level of packet detail shown\n");
    vga_output("on the screen.  High produces a lot of output, but enables you to see all\n");
    vga_output("fields of the packets, whereas low lets you view many packets at once, but\n");
    vga_output("in less detail.  If logging is enabled, the verbosity command also affects\n");
    vga_output("the amount of data written to the log.  Filtered packets will not appear\n");
    vga_output("regardless of verbosity. None is a good choice when you want to see command\n");
    vga_output("output without packets getting in the way, but don't want to stop capture.\n\n");
    return;
  }
  if (strcmpbeg(data, "verbosity none")==1)
  {
    vga_write_output(CHECKMARK);
    vga_output("Setting verbosity to none...\n\n");
    verbosity = 0;
    return;
  }
  if (strcmpbeg(data, "verbosity low")==1)
  {
    vga_write_output(CHECKMARK);
    vga_output("Setting verbosity to low...\n\n");
    verbosity = 1;
    return;
  }
  if (strcmpbeg(data, "verbosity medium")==1)
  {
    vga_write_output(CHECKMARK);
    vga_output("Setting verbosity to medium...\n\n");
    verbosity = 2;
    return;
  }
  if(strcmpbeg(data, "verbosity high")==1)
  {
    vga_write_output(CHECKMARK);
    vga_output("Setting verbosity to high...\n\n");
    verbosity = 3;
    return; 
  }
  cmdErrMsg("");
};

//commands that affect logging//////////////////////////////////////////////////
void setLog(unsigned char* data)
{
  if (strcmpbeg(data,"log help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Log");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("log show          Stop capture and show the current packet log.\n");
    vga_write_output(CHECKMARK);
    vga_output("log on            Activate packet logging.\n");
    vga_write_output(CHECKMARK);
    vga_output("log clear         Erase the packet log from flash memory.\n");
    vga_write_output(CHECKMARK);
    vga_output("log off           Deactivate packet logging and flush the buffer.\n\n");
    vga_output("The log command controls whether or not packets are logged to flash memory.\n");
    vga_output("Packets are logged to flash in the same way they are shown on-screen.\n");
    vga_output("Commands and link state changes are also logged when logging is enabled.\n");
    vga_output("By default, the log is turned off.  Showing the log stops capture.\n\n");
    return;
  }
  if(strcmpbeg(data,"log show"))
  {
    //show the log
    vga_output("Showing the packet log...\n\n");
    log_show();
    return;
  }
  if(strcmpbeg(data,"log on"))
  {
     //turn on the log
     vga_write_output(CHECKMARK);
     vga_output("Packet logging activated...\n\n");
     logging = 1;
     return;
  }
  if(strcmpbeg(data,"log clear"))
  {
    //clear the log
    vga_write_output(CHECKMARK);
    vga_output("Clearing the packet log...\n\n");
    log_clear();
    return; 
  }
  if(strcmpbeg(data,"log off"))
  {
    vga_write_output(CHECKMARK);
    //turn off the log
    vga_output("Flushing log buffer...");
    log_buffer_flush();
    vga_output("done.\n");
    vga_write_output(CHECKMARK);
    vga_output("Packet logging deactivated.\n\n");
    logging = 0;
    return; 
  }
  cmdErrMsg("");
};

//commands that change the appearance of the status bar/////////////////////////
void setStatus(unsigned char* data)
{
  if (strcmpbeg(data,"status help")==1)
  {
    //print a nice border
    int i=0;
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWRT);
    }
    vga_output("Status");
    for(i=0;i<36;i++)
    {
      vga_write_output(ARROWLFT);
    }
    vga_return_output();
    vga_return_output();
    vga_write_output(CHECKMARK);
    vga_output("status stats          Show packet count and link state in status bar.\n");
    vga_write_output(CHECKMARK);
    vga_output("status cpu            Show cpu usage meter in status bar.\n");
    vga_output("These commands control what appears in the status bar.  By default,\n");
    vga_output("the packet counts, runtime and link state are displayed.  \n\n");
    return;
  }
  if(strcmpbeg(data,"status stats"))
  {
    vga_write_output(CHECKMARK);
    vga_output("Displaying stats in status bar...\n\n");
    status_bar = 0;
    return;
  }
  if(strcmpbeg(data,"status cpu"))
  {
    vga_write_output(CHECKMARK);
    vga_output("Displaying cpu usage meter in status bar...\n\n");
    status_bar = 1;
    return;
  }
  cmdErrMsg("");
};

//command error message/////////////////////////////////////////////////////////
void cmdErrMsg(unsigned char* data)
{
  vga_write_output(REDX);
  vga_output("Unrecognized command.  Type help for a list of commands.\n\n");
};

#endif
