#ifndef LCD_C
#define LCD_C

//includes
#include "lcd.h"

//clear LCD
inline void lcd_clear(void)
{
  while(LCD_BUSY);
  usleep(100);
  LCD_CLEAR();          
}

//line return
inline void lcd_newline(void)
{
  while(LCD_BUSY);
  usleep(1000);
  LCD_NEWLINE();          
  usleep(1000);
}

//write one character
inline void lcd_char(char a)
{
  while(LCD_BUSY);
  usleep(100);
  LCD_DATA(a);          
}

//write a string
void lcd_string(const char* ptr, int len)
{
  const char* end=ptr+len;
  for (;ptr<end;ptr++)
  {
    if(*ptr == '\n')
    {
      lcd_newline();
    }
    else
    {
      lcd_char(*ptr);
    }
  } 
}

//initialize LCD
inline LCD_RESULT lcd_init()
{
  usleep(15000);
  LCD_COMMAND(0x1F);    //reset
  usleep(4200);
  LCD_COMMAND(0x1F);    //reset 
  usleep(1000);
  LCD_COMMAND(0x1F);    //reset
  while(LCD_BUSY);
  usleep(100);
  LCD_COMMAND(0x1F);    //reset
  while(LCD_BUSY);
  usleep(100);
  LCD_COMMAND(0x08);    //display off
  while(LCD_BUSY);
  usleep(100);
  LCD_CLEAR();          //clear
  while(LCD_BUSY);
  usleep(100);
  LCD_COMMAND(0x06);    //entry mode set
  while(LCD_BUSY);
  usleep(100);
  LCD_COMMAND(0x0C);    //display on
  return LCD_SUCCESS; 
}

#endif
