#ifndef _LOG_H_
#define _LOG_H_

//inclusions////////////////////////////////////////////////////////////////////
#include "altera_avalon_cfi_flash.h"
#include "keyboard.h"
#include "vga.h"
#include <stdlib.h>
#include "system.h"
#include "sys/alt_irq.h"

//variables/////////////////////////////////////////////////////////////////////
extern unsigned short int logging;
extern unsigned short int verbosity;
extern unsigned short int status_bar;
extern unsigned short int capturing;
extern struct filterRule filter_Rules[5];

//function prototypes///////////////////////////////////////////////////////////
void log_init();                          //init flash memory
void log_buffer_flush();                  //flush the log buffer
void log_char(unsigned char data);        //log a char
void log_data(unsigned char* data);       //write a null-terminated string to the log
void log_hex_data(unsigned short int data, int prefix);     //log a hex value in ascii format
void log_dec_data(unsigned int data);     //log a decimal value in ascii format
void log_clear();                         //clear the log
void log_show();                          //show the log
void save_config();                       //save user configuration
void load_config();                       //load user configuration

#endif //_LOG_H_
