#ifndef PROC_C
#define PROC_C

#include "proc.h"

int idle_time;

//initialize process monitoring/////////////////////////////////////////////////
void proc_init()
{
  proc_reset();  
  alt_irq_register(PROCESS_TIMER_IRQ, 0, (void*)proc_timer_isr);      //register process timer ISR
  IOWR(PROCESS_TIMER_BASE, 0, 0x01);                                  //clear process timer interrupt
  IOWR(PROCESS_TIMER_BASE, 1, 0x07);                                  //start timer running
}

//increments count for current process every 1 ms, this should be pretty much representative
void proc_timer_isr()
{
    ++idle_time;                                                  //increment count for process
    IOWR(PROCESS_TIMER_BASE, 0, 0x01);                                //clear process timer interrupt
}

//reset process timers once a second////////////////////////////////////////////
void proc_reset()
{
   idle_time=0;
}

#endif
