#ifndef VGA_H
#define VGA_H

//inclusions////////////////////////////////////////////////////////////////////
#include <io.h>
#include "system.h"

//defintions////////////////////////////////////////////////////////////////////
#define VGA_WRITE 0x400
#define VGA_STATUS 0x200
#define VGA_ENTER 0x100
#define VGA_OUTPUT 0x000

//constants for useful symbols//////////////////////////////////////////////////
#define CHECKMARK 0x1C
#define ARROWRT 0x1D
#define ARROWLFT 0x1E
#define REDX 0x1F
#define OKAY 0x00
#define REDSQ 0x01
#define GRNSQ 0x02
#define BLUSQ 0x03
#define SPACE 0x20

//function declarations/////////////////////////////////////////////////////////
inline void vga_init(void);                 //initialize VGA (clear screen)
inline void vga_write_output(char a);       //write char to VGA output
inline void vga_return_output(void);        //line return to VGA output
void vga_dec_output(int i);  //print decimal number to VGA output
void vga_hex_output(int i, int prefix);     //print hex byte to VGA output
void vga_output(const char* ptr);           //print null-terminated string to VGA output
inline void vga_write_status(char a);       //write char to VGA status
inline void vga_return_status(void);        //line return to VGA status
void vga_dec_status(int i, int zero_lead);  //print decimal number to VGA output
void vga_hex_status(int i, int prefix);     //print hex byte to VGA output
void vga_status(const char* ptr);           //print null-terminated string to VGA status

#endif
